package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryServiceModelDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryServiceModelDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryServiceModelDao;
import com.friday.custody.entity.DataDictionaryServiceModelEntity;
import com.friday.custody.service.basicService.DataDictionaryServiceModelService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryServiceModelService")
public class DataDictionaryServiceModelServiceImpl extends ServiceImpl<DataDictionaryServiceModelDao, DataDictionaryServiceModelEntity>
        implements DataDictionaryServiceModelService,DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryServiceModelEntity> page = this.page(
                new Query<DataDictionaryServiceModelEntity>().getPage(params),
                new QueryWrapper<DataDictionaryServiceModelEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryServiceModelDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }
    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryServiceModelEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryServiceModelDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryServiceModelDetailsEntity::getOriginValue, DataDictionaryServiceModelDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryServiceModelEntity::getId, DataDictionaryServiceModelEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryServiceModelDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryServiceModelEntity 查询失败！");
        }
        return result;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryServiceModelEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryServiceModelEntity::getKeyStr
                            ,DataDictionaryServiceModelEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}